
//--------------------------------------------------------------------------//
// Title:       nios_bts_port_xcvr_x4_hsma.v                            			//
// Rev:         Rev 1                                                       //
// Author		San Diego - High Speed Design Group                         //
//--------------------------------------------------------------------------//
// Description: NIOS BTS Port For Transceivers                              //
//----------------------------------------------------------------------------
//Copyright  2009 Altera Corporation. All rights reserved.  Altera products
//are protected under numerous U.S. and foreign patents, maskwork rights,
//copyrights and other intellectual property laws.
//                                                                                                     
//This reference design file, and your use thereof, is subject to and
//governed by the terms and conditions of the applicable Altera Reference
//Design License Agreement.  By using this reference design file, you
//indicate your acceptance of such terms and conditions between you and
//Altera Corporation.  In the event that you do not agree with such terms and
//conditions, you may not use the reference design file. Please promptly                         
//destroy any copies you have made.
//
//This reference design file being provided on an "as-is" basis and as an
//accommodation and therefore all warranties, representations or guarantees
//of any kind (whether express, implied or statutory) including, without
//limitation, warranties of merchantability, non-infringement, or fitness for
//a particular purpose, are specifically disclaimed.  By making this
//reference design file available, Altera expressly does not recommend,
//suggest or require that this reference design file be used in combination 
//with any other product not provided by Altera

module  nios_bts_port_xcvr_x4_hsma
(
	// Resets:
    input          					reset_n,
	input							en_cdet_pb,
	input							channel_bond_pb,
	input							start_pb,
	input							create_error_pb,           				
	input		   					xcvr_reset_pb_n,	
    input          					refclk_p,
    output [3:0]   					tx_p,    	  
    input  [3:0]   					rx_p,
 	input							cal_blk_clk_sig,
	input  [7:0]					seriallpbken_dip,    
    output         					led_tx,     
    output         					led_rx,
	input							rx_ss_clk_in,			
    output							tx_ss_clk_out,       	
	input							plls_in_locked,			
	output		    				plls_locked, 
	output							pattern_sync_acquired,
	output							test_complete,
	output							error_latch,
	output							error_irq,
	input							nios_clk,
	input	[19:0]					nios_address,
  	input	      					nios_chipselect,
  	input	      					nios_read,
  	output	[31:0]					nios_readdata,
  	input	      					nios_reset_n,
  	input	      	    		    nios_write,
 	input	[31:0]					nios_writedata,
	output							nios_waitrequest,
	input	[7:0]					avalon_pb,
	input	[7:0]					avalon_dip,
	output	[7:0]					avalon_led											
);  
	 
	nios_bts_port_xcvr_x4_hsma_top	nios_bts_port_xcvr_x4_hsma_top_i
	(
		.reset_n                           (reset_n                      ),
		.en_cdet_pb                        (en_cdet_pb                   ),
		.channel_bond_pb                   (channel_bond_pb              ),
		.start_pb                          (start_pb                     ),
		.create_error_pb                   (create_error_pb              ),
		.xcvr_reset_pb_n	               (xcvr_reset_pb_n	             ),
		.refclk_p                          (refclk_p                     ),
		.tx_p    	                       (tx_p    	                 ),
		.rx_p                              (rx_p                         ),
		.cal_blk_clk_sig                   (cal_blk_clk_sig              ),
		.seriallpbken_dip                  (seriallpbken_dip             ),
		.led_tx                            (led_tx                       ),
		.led_rx                            (led_rx                       ),
		.rx_ss_clk_in			           (rx_ss_clk_in			     ),
		.tx_ss_clk_out       	           (tx_ss_clk_out       	     ),
		.plls_in_locked			           (plls_in_locked			     ),
		.plls_locked                       (plls_locked                  ),
		.pattern_sync_acquired             (pattern_sync_acquired        ),
		.test_complete                     (test_complete                ),
		.error_latch                       (error_latch                  ),
		.error_irq                         (error_irq                    ),
		.nios_clk                          (nios_clk                     ),
		.nios_address                      (nios_address                 ),
		.nios_chipselect                   (nios_chipselect              ),
		.nios_read                         (nios_read                    ),
		.nios_readdata                     (nios_readdata                ),
		.nios_reset_n                      (nios_reset_n                 ),
		.nios_write                        (nios_write                   ),
		.nios_writedata                    (nios_writedata               ),
		.nios_waitrequest                  (nios_waitrequest             ),
		.avalon_pb                         (avalon_pb                    ),
		.avalon_dip                        (avalon_dip                   ),
		.avalon_led				           (avalon_led				     )
	);


endmodule