//
//Copyright  2005 Altera Corporation. All rights reserved.  Altera products 
//are protected under numerous U.S. and foreign patents, maskwork rights, 
//copyrights and other intellectual property laws.  
//
//This reference design file, and your use thereof, is subject to and governed
//by the terms and conditions of the applicable Altera Reference Design 
//License Agreement.  By using this reference design file, you indicate your
//acceptance of such terms and conditions between you and Altera Corporation.
//In the event that you do not agree with such terms and conditions, you may
//not use the reference design file. Please promptly destroy any copies you 
//have made.
//
//This reference design file being provided on an "as-is" basis and as an 
//accommodation and therefore all warranties, representations or guarantees
//of any kind (whether express, implied or statutory) including, without 
//limitation, warranties of merchantability, non-infringement, or fitness for
//a particular purpose, are specifically disclaimed.  By making this reference
//design file available, Altera expressly does not recommend, suggest or 
//require that this reference design file be used in combination with any 
//other product not provided by Altera

/* NOTICE: The information contained in this file is proprietary   *
* to Altera and is being made available to Altera's customers      *
* under strict non-disclosure agreements.  Use or disclosure of    *
* this information is permissible only under the terms of          *
* existing non-disclosure agreements.                              *
********************************************************************/

/*------------------------------------------------------------------------------------------
--                                                                                        --
-- Title:       ram_dual.v                                                                --
-- Rev:         Rev 1                                                                     --
-- Modified:    October 17, 2005                                                          --
-- Author:      David Johnson                                                             --
--                                                                                        --
--------------------------------------------------------------------------------------------
*/

// Use this to infer M9K or M4K or M512 etc Memories:

module ram_dual	(
					q,
					addr_in,
					addr_out,
					d,
					we,
					clk1,
					clk2
				);
				
	parameter	data_width	=	8;
	parameter	mem_size	=	32;
	parameter	addr_width	=	5;	// log2(addr_width)

	output	[data_width-1:0]	q;
	input 	[data_width-1:0]	d;
	input 	[addr_width-1:0]	addr_in;                  
	input 	[addr_width-1:0]	addr_out;
	input 						we;
	input						clk1;
	input						clk2;
	
	reg [addr_width-1:0]		addr_out_reg;
	reg [data_width-1:0]		q;
	reg [data_width-1:0]		mem [mem_size-1:0];	/* sy nth esis ra mst yle = "M512" */
	 
	
	always @(posedge clk1)
	begin
		if (we)
		begin
			mem[addr_in] <= d;
		end
	end
 
	always @(posedge clk2)
	begin
		q				<= mem[addr_out_reg];
		addr_out_reg	<= addr_out;
	end     
	
endmodule


